package com.example.mylog;


import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;

import android.app.Service;
import android.content.Context;
import android.content.Intent;
import android.os.IBinder;
import android.telephony.PhoneStateListener;
import android.telephony.TelephonyManager;
import android.text.format.Time;
import android.util.Log;



public class PhoneService extends Service {
	
	  private static final String TAG = PhoneService.class.getSimpleName();


	// Create Telephony + Listener variables
	
    public TelephonyManager telephony;
	public MyPhoneStateListener phoneListener;
	
	@Override
	public IBinder onBind(Intent intent) {
		return null;
	}
	
	@Override
	public void onCreate() {
		super.onCreate();
		
		// Put a Listener on the Phone-State

		telephony = (TelephonyManager)getSystemService(Context.TELEPHONY_SERVICE);
		phoneListener = new MyPhoneStateListener();
	    telephony.listen(phoneListener,PhoneStateListener.LISTEN_CALL_STATE);
  		Log.d(TAG, "Listener created");

		
		
	}
	
	
		/* 
    @Override
    public void onCreate(Bundle savedInstanceState) {
    	  super.onCreate(savedInstanceState);
    	      	
    	  
    	Get calls 
        Cursor c = getContentResolver().query(
	               android.provider.CallLog.Calls.CONTENT_URI,
	               null,
	               null,
	               null,
	               android.provider.CallLog.Calls.DATE+ " DESC");
	   startManagingCursor(c);

           // Now create an adapter and set it to display using android.R.layout.simple_list_item_2
           SimpleCursorAdapter calls = new SimpleCursorAdapter(
        		   this,
                   android.R.layout.simple_list_item_2, 
                   c, 
                   new String[] { android.provider.CallLog.Calls.CACHED_NAME, android.provider.CallLog.Calls.NUMBER }, 
                   new int[] { android.R.id.text1, android.R.id.text2 });
           setListAdapter(calls);*/  
           
           
       	/* Save calls in database   
           
        db = new DBAdapter(getApplicationContext());
        
        
        class MyPhoneStateServiceUpdater extends PhoneStateListener	{

        	public void onCallStateChanged (int state, String incomingNumber)

        	{

        		loc.getLatitude();

        		loc.getLongitude();
        		
        		Date d = new Date();
        		Time t = new Time();
        		t.setToNow();
        		String date = Calendar.get(Calendar.DAY_OF_WEEK) + "." + Calendar.get(Calendar.MONTH) + "." + Calendar.get(Calendar.YEAR) - 1900;
        		String time = t.hour +":" + t.minute + ":" + t.second;
        		
        		
        		String Text = "Time: " + t.hour +":" + t.minute + ":" + t.second+"  Loc-"+counter++ +

        		"--- Latitud = " + loc.getLatitude() +

        		"Longitud = " + loc.getLongitude() +"\n";

        		
        		db.open();
        		db.insertLocation(loc.getLatitude(), loc.getLongitude(), time);
        		
        		Toast.makeText( getApplicationContext(),Text,Toast.LENGTH_SHORT).show();

        	}


        }
        
        */
        
             
	
	//////// Private Class MyPhoneStateListener /////////
	
	private class MyPhoneStateListener extends PhoneStateListener {
		
	    Calendar calendar = new GregorianCalendar();
	    int i = calendar.get(Calendar.MONTH) + 1;
		
		String date = calendar.get(Calendar.DATE) + "." + i + "." + calendar.get(Calendar.YEAR);
		String time = calendar.get(Calendar.HOUR) + ":" + calendar.get(Calendar.MINUTE) + ":" + calendar.get(Calendar.SECOND);

  		String name;
  		String phonenumber;
  		String duration;
  		String callclassification;
  		
		  public void onCallStateChanged(int state,String incomingNumber){
			  
			  name = android.provider.CallLog.Calls.CACHED_NAME;
			  phonenumber = android.provider.CallLog.Calls.NUMBER;
			  duration = android.provider.CallLog.Calls.DURATION;
			  
		  		Log.d(TAG, "STATE HAS CHANGED!");

			  
			  switch(state){
			  	case TelephonyManager.CALL_STATE_IDLE:
			  		Log.d(TAG, "---booooooo-----");
			  		break;
			  	case TelephonyManager.CALL_STATE_OFFHOOK:
			  		callclassification = "Outgoing Call";
			  		Log.d(TAG, "Calling somebody");
			  		Log.d(TAG, date);
			  		Log.d(TAG, time);
			  		break;
		    case TelephonyManager.CALL_STATE_RINGING:
		    		Log.d(TAG, "RINGING");
			  		Log.d(TAG, date);
			  		Log.d(TAG, time);
			  		callclassification = "Incoming Call";
		    		break;
			  }
		  }

	}

	
	
}